package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;

import java.time.Duration;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("MetricsRequest")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class MetricsRequest implements Marshallable {
	private String metric;
	private Duration duration;

    //
	public String getMetric() {
	    return metric;
	}
	public void setMetric(final String value) {
	    this.metric = value;
	}

	public MetricsRequest metric(final String value) {
	    setMetric(value);
	    return this;
	}
	public Duration getDuration() {
	    return duration;
	}
	public void setDuration(final Duration value) {
	    this.duration = value;
	}

	public MetricsRequest duration(final Duration value) {
	    setDuration(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.metric == null || this.metric.length() == 0)) {
            marshaller.writeString(1, this.metric);
        }
        if (!(this.duration == null)) {
            marshaller.writeDuration(2, this.duration);
        }
        return marshaller.array();
    }
}
